# Niku
Effortless property builder for composing maintainable Flutter UI

<p align="center">
  <img src="https://raw.githubusercontent.com/saltyaom/niku/main/doc/images/niku.jpg" alt="Niku" />
</p>

## Why
Creating UI in Flutter is easy. Its declarative enables developers to control every detail and outcome of how it should be.

To create styling in Flutter, developers have to describe every detail to Widget. It's like low-level programming UI, having to adapt between property is hard when some are more complex than others, for instance, MaterialStateProperty.

When the codebase gets more complex, the syntax of Flutter itself is too verbose, nested than it should be, result being hard to maintain mostly known as "Nested Hell".

Niku helps to solve the problem by providing a toolkit to style widgets with property builders. To provide a smoother, shorter yet, more straightforward and maintainable way to compose styling in Flutter.

<p align="center">
  <img src="https://raw.githubusercontent.com/saltyaom/niku/main/doc/images/drake.jpg" alt="Comparison" />
</p>

## Documentation
Documentation and getting start can be find on [https://niku.saltyaom.com](niku.saltyaom.com)

- [Introduction and why](https://niku.saltyaom.com/docs/introduction)
- [Overview](https://niku.saltyaom.com/docs/overview)
- [Property Builder](https://niku.saltyaom.com/docs/property-builder)
- [Naming Convention](https://niku.saltyaom.com/docs/naming-convention)
- [Style Property Builder](https://niku.saltyaom.com/docs/style-builder)
- [Parent Builder](https://niku.saltyaom.com/docs/parent-builder)

### License
Niku is MIT Licensed.

### Maintainers
- [SaltyAom](https://github.com/saltyaom)
